﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace Radio
{
    public partial class Form1 : Form
    {

        [DllImport("winmm.dll")]
        public static extern int waveOutGetVolume(IntPtr hwo, out uint dwVolume);

        [DllImport("winmm.dll")]
        public static extern int waveOutSetVolume(IntPtr hwo, uint dwVolume);

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            trackBar3.Value = trackBar2.Value = trackBar1.Value = GetVolume();
            SetTimer();
        }
        void SetTimer()
        {
            int[] minutes = new int[2];
            int minute = DateTime.Now.Minute;
            minutes[0] = minute - (int)numericUpDown1.Value;
            minutes[1] = minute - (int)numericUpDown2.Value;
            for(int i = 0; i < 2; i++)
                if(minutes[i] <= 0)
                    minutes[i] += 60;
            int next = Math.Min(minutes[0],minutes[1]);
            timer1.Interval = next * 60000 - DateTime.Now.Millisecond;
            if (minutes[0] == next)
                trackbar = Controls.IndexOf(trackBar1);
            else
                trackbar = Controls.IndexOf(trackBar2);
            timer1.Start();   
        }

        int trackbar;

        private void numericUpDown1_ValueChanged(object sender, EventArgs e)
        {
            SetTimer();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            timer1.Stop();
            SetVolume(((TrackBar)Controls[trackbar]).Value);
            SetTimer();
        }

        void SetVolume(int volume)
        {
            int NewVolume = (ushort.MaxValue / 100) * volume;
            uint NewVolumeAllChannels = (((uint)NewVolume & 0x0000ffff) | ((uint)NewVolume << 16));
            waveOutSetVolume(IntPtr.Zero, NewVolumeAllChannels);
        }

        int GetVolume()
        {
            uint vol = 0;
            waveOutGetVolume(IntPtr.Zero, out vol);
            ushort CalcVol = (ushort)(vol & 0x0000ffff);
            return CalcVol / (ushort.MaxValue / 100);
        }

        private void trackBar3_Scroll(object sender, EventArgs e)
        {
            SetVolume(trackBar3.Value);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            trackBar3.Value = GetVolume();
        }
    }
}
